<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Exercice 3</title>
    <style>
      * {
        margin: 0;
        width: 100%;
        height: 100%;
      }
      canvas {
        background-color: #d5e899;
      }
    </style>
  </head>
  <body>
    <script>
      window.onload = () => {
        init();
        window.addEventListener("resize", init, false);
      };
      // Déclaration de variables
      let canvas = document.createElement("canvas");
      canvas.id = "canvas";
      canvas.width = window.innerWidth;
      canvas.height = window.innerHeight;

      let body = document.getElementsByTagName("body")[0];

      body.appendChild(canvas);

      let ctx = canvas.getContext("2d");
      let basketX = canvas.width / 3;
      let basketY = canvas.height / 6;
      let donuts = [];
      let minx = Math.ceil(30);
      let maxx = Math.floor(canvas.width - 30);
      let miny = -30;
      let maxy = -2000;
      let score = 0;
      let count = 0;
      let checky = canvas.height;
      let gamestatus = 0;
      let donutstatus = 0;
      let cmiddlex = canvas.width / 2;
      let cmiddley = canvas.height / 2;
      let move = false;
      let name = "Nom de la marque";
      let game;
      let flag = true;
      let share = "Partager votre score sur : ";
      let colors = [
        { color: "#fa626d" },
        { color: "#0ff1ce" },
        { color: "#fcea8b" },
        { color: "#a020f0" },
        { color: "#e76aa3" },
        { color: "#eebbf5" },
        { color: "#008080" },
        { color: "#fcea8b" },
        { color: "#805b00" },
        { color: "#800020" },
      ];

      function init() {
        canvas.width = window.innerWidth;
        canvas.height = window.innerHeight;

        basketX = canvas.width / 3;
        basketY = canvas.height / 6;

        cmiddlex = canvas.width / 2;
        cmiddley = canvas.height / 2;
        if (gamestatus == 0) {
          drawStart();
        }
        if (gamestatus == 1) {
          draw();
        }
        if (gamestatus == 2) {
          finish();
        }
      }
      // Création d'un tableau contenant les donuts
      for (a = 0; a < colors.length; a++) {
        let location = new Object();
        location.x = rand(maxx, minx);
        location.y = rand(maxy, miny);
        location.status = 1;
        let icolor = Math.floor(Math.random() * colors.length);
        let color = colors[icolor].color;
        location.color = color;
        donuts.push(location);
      }

      // Déclaration variable tot = longueur du tableau de donuts
      let tot = donuts.length;

      // Event listener click sur les boutons
      canvas.addEventListener("click", (e) => {
        let clientX = e.offsetX;
        let clientY = e.offsetY;
        if (gamestatus == 0) {
          if (
            clientX >= canvas.width / 2 - 80 &&
            clientX <= canvas.width / 2 + 80 &&
            clientY >= canvas.height - canvas.height / 3 - 40 &&
            clientY <= canvas.height - canvas.height / 3 + 40
          ) {
            donutstatus = 1;
            gamestatus = 1;
            draw();
          }
        }
        if (gamestatus == 2) {
          if (
            clientX > cmiddlex + 200 &&
            clientX < cmiddlex + 280 &&
            clientY > canvas.height - 85 &&
            clientY < canvas.height - 45 
          ) {
            window.location.href = "https://twitter.com/?lang=fr";
          }
        }
      });

      // Event listener mouse up
      canvas.addEventListener("mouseup", (e) => {
        move = false;
      });

      // Event listener mouse down sur le panier et lance le jeu
      canvas.addEventListener("mousedown", (e) => {
        let clientX = e.offsetX;
        let clientY = e.offsetY;
        if (gamestatus == 1) {
          if (
            clientX > basketX &&
            clientX < basketX + canvas.width / 3 &&
            clientY > canvas.height - canvas.height / 6 &&
            clientY < canvas.height
          ) {
            move = true;
            if (flag) {
              game = setInterval(draw, 1);
              flag = false;
            }
          }
        }
      });

      // Event listener mouse move pour bouger le panier
      canvas.addEventListener(
        "mousemove",
        (e) => {
          if (gamestatus == 1) {
            if (move) {
              basketX = e.offsetX - 150;
            }
          }
        },
        false
      );

      // Fonction random
      function rand(min, max) {
        return Math.round(Math.random() * (max - min + 1) + min);
      }

      // Fonction dessin score
      function drawScore() {
        if (gamestatus == 1) {
          ctx.font = "17px Arial";
          ctx.fillStyle = "#a38966";
          ctx.fillText("Score: " + score + " /" + tot, canvas.width / 2, 20);
        }
      }

      // Fonction dessin donuts
      function drawDonut() {
        if (donutstatus == 1) {
          for (c = 0; c < donuts.length; c++) {
            let donut = donuts[c];
            if (donut.status == 1) {
              if (
                donut.x > basketX &&
                donut.x < basketX + canvas.width / 3 &&
                donut.y > canvas.height - basketY &&
                donut.y < canvas.height
              ) {
                donut.status = 0;
                score++;
              } else {
                ctx.beginPath();
                ctx.arc(donut.x, donut.y, 28, 0, Math.PI * 2);
                ctx.fillStyle = donut.color;
                ctx.fill();
                ctx.beginPath();
                ctx.arc(donut.x, donut.y, 10, 0, Math.PI * 2);
                ctx.fillStyle = "#d5e899";
                ctx.fill();
                ctx.closePath();
                donut.y++;
              }
              if (donut.y == checky) {
                count++;
              }
            }
          }
        }
      }
      // Fonction dessin écran d'accueil
      function drawStart() {
        if (gamestatus == 0) {
          ctx.beginPath();
          ctx.font = "40px serif";
          ctx.textAlign = "center";
          ctx.fillStyle = "#a38966";
          ctx.fillText(name, canvas.width / 2, canvas.height / 3);
          ctx.rect(
            canvas.width / 2 - 80,
            canvas.height - canvas.height / 3 - 40,
            160,
            80
          );
          ctx.fillStyle = "#a38966";
          ctx.fill();
          ctx.font = "30px serif";
          ctx.fillStyle = "#d5e899";
          ctx.fillText(
            "Jouer !",
            canvas.width / 2,
            canvas.height - canvas.height / 3
          );
        }
      }
      // Fonction dessin panier
      function drawBascket() {
        if (gamestatus == 1) {
          if (basketX <= 0) {
            basketX = 0;
          }
          if (basketX > (2 * canvas.width) / 3) {
            basketX = (2 * canvas.width) / 3;
          }

          ctx.beginPath();
          ctx.moveTo(basketX, canvas.height - basketY);
          ctx.lineTo(basketX + canvas.width / 3, canvas.height - basketY);
          ctx.lineTo(basketX + canvas.width / 4, canvas.height);
          ctx.lineTo(basketX + canvas.width / 12, canvas.height);
          ctx.lineTo(basketX, canvas.height - basketY);
          ctx.fillStyle = "#a38966";
          ctx.fill();
          ctx.closePath();
        }
      }

      // Fonction dessin écran de fin
      function finish() {
        let text =
          "Félicitations vous avez attrapé : " +
          score +
          " céréales sur " +
          tot +
          " !!!";
        let words = text.split(" ");
        let twitterx = canvas.width + 80;
        let line = "";
        if (gamestatus == 2) {
          ctx.beginPath();
          ctx.font = "60px serif";
          ctx.textAlign = "center";
          ctx.fillStyle = "#a38966";
          ctx.fillText(name, cmiddlex, 200, cmiddlex);
          ctx.font = "22px serif";
          ctx.fillStyle = "#a38966";

          for (d = 0; d < words.length; d++) {
            let testline = line + words[d] + " ";
            let metrics = ctx.measureText(testline);
            let textwidth = metrics.width;
            if (textwidth >= canvas.width / 6) {
              ctx.fillText(line, cmiddlex, cmiddley);
              line = words[d] + " ";
              cmiddley += 24;
            } else {
              line = testline;
            }
          }
          ctx.fillText(line, cmiddlex, cmiddley);
          ctx.font = "22px serif";
          ctx.fillStyle = "#a38966";
          ctx.fillText(share, cmiddlex, canvas.height - 60, 200);
          ctx.rect(cmiddlex + 200, canvas.height - 85, 80, 40);
          ctx.fillStyle = "#a38966";
          ctx.fill();
          ctx.font = "20px serif";
          ctx.fillStyle = "#d5e899";
          ctx.fillText("Twitter", cmiddlex + 240, canvas.height - 60);
        }
      }

      // Fonction appel des dessins et nettoie le canvas
      function draw() {
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        drawDonut();
        drawScore();
        drawBascket();

        if (tot == score + count || tot == score) {
          gamestatus = 2;
          clearInterval(game);
          ctx.clearRect(0, 0, canvas.width, canvas.height);
          finish();
        }
      }

      drawStart();
    </script>
  </body>
</html>
